package ch.unige.aou.controller.admin;

import java.util.Map;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.security.AdminPermissions;
import ch.unige.solidify.security.NoOnePermissions;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.notification.Event;
import ch.unige.aou.rest.UrlPath;

@AdminPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_EVENTS)
public class EventController extends ResourceController<Event> {

  @Override
  public HttpEntity<RestCollection<Event>> list(Event search, Pageable pageable) {
    return super.list(search, pageable);
  }

  @Override
  public HttpEntity<Event> get(@PathVariable String id) {
    return super.get(id);
  }

  @NoOnePermissions
  @Override
  public HttpEntity<Event> update(@PathVariable String id, @RequestBody Map<String, Object> updateMap) {
    return super.update(id, updateMap);
  }
}
