package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.controller.ControllerWithHateoasHome;
import ch.unige.solidify.security.EveryonePermissions;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.ModuleList;
import ch.unige.aou.service.MonitorService;

@EveryonePermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(ch.unige.aou.rest.UrlPath.ADMIN_MODULES)
public class ModuleListController implements ControllerWithHateoasHome {

  private final MonitorService monitorService;

  public ModuleListController(MonitorService monitorService) {
    this.monitorService = monitorService;
  }

  @GetMapping
  public HttpEntity<ModuleList> moduleList() {
    return new ResponseEntity<>(this.monitorService.getModuleUrls(), HttpStatus.OK);
  }

}
