package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.security.RootPermissions;

import ch.unige.aou.business.ScheduledTaskService;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.controller.AouResourceController;
import ch.unige.aou.model.schedule.ScheduledTask;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.UrlPath;

@RootPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_SCHEDULED_TASKS)
public class ScheduledTaskController extends AouResourceController<ScheduledTask> {

  @PostMapping(SolidifyConstants.URL_SEP + AouActionName.SCHEDULE_ENABLED_TASKS)
  public HttpStatus scheduleEnabledTasks() {
    ((ScheduledTaskService) this.itemService).scheduleEnabledTasks();
    return HttpStatus.OK;
  }

  @PostMapping(SolidifyConstants.URL_SEP + AouActionName.DISABLE_TASKS_SCHEDULING)
  public HttpStatus disableTasksScheduling() {
    ((ScheduledTaskService) this.itemService).disableAllTasksScheduling();
    return HttpStatus.OK;
  }

  @PostMapping(SolidifyConstants.URL_ID_PLUS_SEP + AouActionName.KILL_TASK)
  public HttpStatus killTask(@PathVariable String id) {
    ScheduledTask scheduledTask = this.itemService.findOne(id);
    ((ScheduledTaskService) this.itemService).killTask(scheduledTask);
    return HttpStatus.OK;
  }
}
