package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.settings.LicenseGroup;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class LicenseGroupClientService extends ResourceClientService<LicenseGroup> implements LicenseGroupClientServiceInterface {

  public LicenseGroupClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyConstants.URL_SEP + ResourceName.LICENSE_GROUPS, LicenseGroup.class, ModuleName.ADMIN, restClientTool, env);
  }

  @Override
  public List<LicenseGroup> findAll() {
    return this.findAll(LicenseGroup.class);
  }

  @Override
  public List<LicenseGroup> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, LicenseGroup.class);
  }
}
