package ch.unige.aou.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.auth.model.AuthApplicationRole;
import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.model.security.User;

@Repository
public interface UserRepository extends SolidifyRepository<User> {

  boolean existsByExternalUid(String externalUid);

  User findByExternalUid(String externalUid);

  User findByEmail(String email);

  User findByPersonResId(String personId);

  @Query(value = "SELECT u FROM User u WHERE u.applicationRole.resId='" + AuthApplicationRole.ADMIN_ID + "' OR u.applicationRole.resId='"
          + AuthApplicationRole.ROOT_ID + "'")
  List<User> findAdminOrRootUsers();
}
