package ch.unige.aou.service.elasticsearch;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.stereotype.Service;

import controller.DataMgmtController;

import ch.unige.solidify.IndexProperties;
import ch.unige.solidify.index.ElasticsearchClientProvider;
import ch.unige.solidify.index.indexing.elasticsearch.ElasticsearchService;

import ch.unige.aou.model.index.PublicationIndexEntry;

@Service
@ConditionalOnBean(DataMgmtController.class)
public class PublicationIndexingService extends ElasticsearchService<PublicationIndexEntry> {
  public PublicationIndexingService(
          IndexProperties indexProperties,
          ElasticsearchClientProvider elasticsearchClientProvider) {
    super(indexProperties, elasticsearchClientProvider);
  }

  @Override
  public String getIndexName(String indexName) {
    return indexName;
  }

  @Override
  protected PublicationIndexEntry getMetadataObject() {
    return null;
  }
}
