package ch.unige.aou.test.admin;

import static org.junit.jupiter.api.Assertions.assertEquals;

import java.time.OffsetDateTime;

import ch.unige.solidify.model.GlobalBanner;

public abstract class GlobalBannerIT extends AbstractAdminIT {

  protected GlobalBanner createTestGlobalBanner(String name, GlobalBanner.GlobalBannerType type, boolean enabled, OffsetDateTime startDate,
          OffsetDateTime endDate) {
    this.restClientTool.sudoAdmin();
    GlobalBanner globalBanner = new GlobalBanner();
    globalBanner.setName(this.getTemporaryTestLabel(name));
    globalBanner.setType(type);
    globalBanner.setEnabled(enabled);
    globalBanner.setStartDate(startDate);
    globalBanner.setEndDate(endDate);
    globalBanner = this.globalBannerService.create(globalBanner);
    this.restClientTool.exitSudo();
    return globalBanner;
  }

  protected void assertsGlobalBanner(GlobalBanner expectedGlobalBanner, GlobalBanner actualGlobalBanner) {
    assertEquals(expectedGlobalBanner.getName(), actualGlobalBanner.getName());
    this.assertEqualsWithoutNanoSeconds(expectedGlobalBanner.getCreationTime(), actualGlobalBanner.getCreationTime());
    assertEquals(expectedGlobalBanner.getType(), actualGlobalBanner.getType());
    assertEquals(expectedGlobalBanner.getEnabled(), actualGlobalBanner.getEnabled());
    assertEquals(expectedGlobalBanner.getStartDate(), actualGlobalBanner.getStartDate());
    assertEquals(expectedGlobalBanner.getEndDate(), actualGlobalBanner.getEndDate());
  }

  @Override
  protected void deleteFixtures() {
    this.restClientTool.sudoAdmin();
    this.clearGlobalBannerFixtures();
    this.restClientTool.exitSudo();
  }
}
