package ch.unige.aou.model.notification;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonIgnore;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.AouResourceNormalized;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.model.settings.Person;

@Entity
public class Event extends AouResourceNormalized {

  @NotNull
  @ManyToOne
  @JoinColumn(name = AouConstants.DB_EVENT_TYPE_ID)
  private EventType eventType;

  @NotNull
  @ManyToOne
  @JoinColumn(name = AouConstants.DB_PUBLICATION_ID)
  private Publication publication;

  @ManyToOne
  private Person triggerBy;

  @OneToMany(mappedBy = "event", cascade = CascadeType.ALL, orphanRemoval = true)
  @JsonIgnore
  private List<Notification> notifications = new ArrayList<>();

  private String message;

  public EventType getEventType() {
    return this.eventType;
  }

  public Publication getPublication() {
    return this.publication;
  }

  public String getMessage() {
    return this.message;
  }

  public void setEventType(EventType eventType) {
    this.eventType = eventType;
  }

  public void setPublication(Publication publication) {
    this.publication = publication;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public Person getTriggerBy() {
    return this.triggerBy;
  }

  public void setTriggerBy(Person emitter) {
    this.triggerBy = emitter;
  }

  public List<Notification> getNotifications() {
    return this.notifications;
  }

  public void setNotifications(List<Notification> notifications) {
    this.notifications = notifications;
  }
}
