package ch.unige.aou.model.publication;

import java.util.Objects;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;

import com.fasterxml.jackson.annotation.JsonIgnore;

import ch.unige.solidify.rest.JoinResource;

@Entity
public class PublicationSubtypeContributorRole extends JoinResource<PublicationSubtypeContributorRolePkId> {

  public final static String PATH_TO_CONTRIBUTOR_ROLE = "compositeKey.contributorRole";
  public final static String PATH_TO_PUBLICATION_SUBTYPE = "compositeKey.publicationSubtype";

  @EmbeddedId
  @JsonIgnore
  private PublicationSubtypeContributorRolePkId compositeKey = new PublicationSubtypeContributorRolePkId();

  /**
   * Property allowing to sort file types in lists
   */
  @Column(nullable = false)
  private int sortValue;

  /****************************************************************/

  public PublicationSubtype getPublicationSubtype() {
    return this.compositeKey.getPublicationSubtype();
  }

  public void setPublicationSubtype(PublicationSubtype publicationSubtype) {
    this.compositeKey.setPublicationSubtype(publicationSubtype);
  }

  public ContributorRole getContributorRole() {
    return this.compositeKey.getContributorRole();
  }

  public void setContributorRole(ContributorRole contributorRole) {
    this.compositeKey.setContributorRole(contributorRole);
  }

  public int getSortValue() {
    return this.sortValue;
  }

  public void setSortValue(int sortValue) {
    this.sortValue = sortValue;
  }

  /****************************************************************/

  @Override
  public PublicationSubtypeContributorRolePkId getCompositeKey() {
    return this.compositeKey;
  }

  @Override
  public void setCompositeKey(PublicationSubtypeContributorRolePkId compositeKey) {
    this.compositeKey = compositeKey;
  }

  /*************************************************************************************/

  @Override
  public boolean equals(Object o) {
    if (this == o)
      return true;
    if (o == null || this.getClass() != o.getClass())
      return false;

    PublicationSubtypeContributorRole that = (PublicationSubtypeContributorRole) o;

    return Objects.equals(this.getPublicationSubtype(), that.getPublicationSubtype()) &&
            Objects.equals(this.getContributorRole(), that.getContributorRole());
  }

  @Override
  public int hashCode() {
    int result = super.hashCode();
    result = 31 * result + this.getPublicationSubtype().hashCode();
    result = 31 * result + this.getContributorRole().hashCode();
    return result;
  }
}
