package ch.unige.aou.model.publication;

import java.io.Serializable;
import java.util.Objects;
import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import ch.unige.aou.AouConstants;

@Embeddable
public class PublicationSubtypeContributorRolePkId implements Serializable {
  private static final long serialVersionUID = 64684894123187L;

  @ManyToOne
  @JoinColumn(name = AouConstants.DB_PUBLICATION_SUBTYPE_ID)
  private PublicationSubtype publicationSubtype;

  @ManyToOne
  @JoinColumn(name = AouConstants.DB_CONTRIBUTOR_ROLE_ID)
  private ContributorRole contributorRole;

  public PublicationSubtype getPublicationSubtype() {
    return this.publicationSubtype;
  }

  public void setPublicationSubtype(PublicationSubtype publicationSubtype) {
    this.publicationSubtype = publicationSubtype;
  }

  public ContributorRole getContributorRole() {
    return this.contributorRole;
  }

  public void setContributorRole(ContributorRole contributorRole) {
    this.contributorRole = contributorRole;
  }

  @Override
  public boolean equals(final Object other) {
    if (this == other) {
      return true;
    }

    if (!(other instanceof PublicationSubtypeContributorRolePkId)) {
      return false;
    }

    final PublicationSubtypeContributorRolePkId castOther = (PublicationSubtypeContributorRolePkId) other;
    return Objects.equals(this.getPublicationSubtype(), castOther.getPublicationSubtype()) && Objects
            .equals(this.getContributorRole(), castOther.getContributorRole());
  }

  @Override
  public int hashCode() {
    return Objects.hash(this.getPublicationSubtype(), this.getContributorRole());
  }
}
