package ch.unige.aou.model.security;

import com.fasterxml.jackson.annotation.JsonIgnore;

public class UserDisplayableInfos {
  private String firstName;
  private String lastName;
  private String orcid;
  private PersonAvatar avatar;

  public UserDisplayableInfos() {
  }

  public UserDisplayableInfos(User user) {
    if (user.getPerson() != null) {
      this.firstName = user.getPerson().getFirstName();
      this.lastName = user.getPerson().getLastName();
      this.orcid = user.getPerson().getOrcid();
      this.avatar = user.getPerson().getAvatar();
    } else {
      this.firstName = user.getFirstName();
      this.lastName = user.getLastName();
    }
  }

  public String getFirstName() {
    return this.firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public String getLastName() {
    return this.lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public String getOrcid() {
    return this.orcid;
  }

  public void setOrcid(String orcid) {
    this.orcid = orcid;
  }

  public PersonAvatar getAvatar() {
    return this.avatar;
  }

  public void setAvatar(PersonAvatar avatar) {
    this.avatar = avatar;
  }

  @JsonIgnore
  public String getFullName() {
    return this.getLastName() + ", " + this.getFirstName();
  }
}
