package ch.unige.aou.model.settings;

import java.io.Serializable;
import java.util.Objects;
import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.publication.PublicationSubtype;

@Embeddable
public class ValidationRightKey implements Serializable {

  private static final long serialVersionUID = 15869983822477L;

  @ManyToOne
  @JoinColumn(name = AouConstants.DB_STRUCTURE_ID, referencedColumnName = AouConstants.DB_RES_ID)
  private Structure structure;

  @ManyToOne
  @JoinColumn(name = AouConstants.DB_PERSON_ID, referencedColumnName = AouConstants.DB_RES_ID)
  private Person person;

  @ManyToOne
  @JoinColumn(name = AouConstants.DB_PUBLICATION_SUBTYPE_ID, referencedColumnName = AouConstants.DB_RES_ID)
  private PublicationSubtype publicationSubtype;

  /*************************************************************************************/

  public Structure getStructure() {
    return this.structure;
  }

  public void setStructure(Structure structure) {
    this.structure = structure;
  }

  public Person getPerson() {
    return this.person;
  }

  public void setPerson(Person person) {
    this.person = person;
  }

  public PublicationSubtype getPublicationSubtype() {
    return this.publicationSubtype;
  }

  public void setPublicationSubtype(PublicationSubtype publicationSubtype) {
    this.publicationSubtype = publicationSubtype;
  }

  /*************************************************************************************/

  @Override
  public boolean equals(Object other) {
    if (this == other) {
      return true;
    }
    if (other == null || this.getClass() != other.getClass()) {
      return false;
    }

    ValidationRightKey castOther = (ValidationRightKey) other;
    return Objects.equals(this.getStructure(), castOther.getStructure())
            && Objects.equals(this.getPerson(), castOther.getPerson())
            && Objects.equals(this.getPublicationSubtype(), castOther.getPublicationSubtype());
  }

  @Override
  public int hashCode() {
    return Objects.hash(this.getStructure(), this.getPerson(), this.getPublicationSubtype());
  }
}
