package ch.unige.aou.model.xml.deposit;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.deser.std.StdDeserializer;

import ch.unige.solidify.util.StringTool;

public abstract class AouStdDeserializer<T> extends StdDeserializer<T> {

  public AouStdDeserializer() {
    // empty constructor required to run in annotation
    this(null);
  }

  public AouStdDeserializer(Class<?> vc) {
    super(vc);
  }

  protected boolean nodeHasTextValue(JsonNode node) {
    return node != null && !node.isNull() && !StringTool.isNullOrEmpty(node.textValue());
  }

  protected boolean nodeHasValue(JsonNode node) {
    return node != null && !node.isNull() && !StringTool.isNullOrEmpty(node.asText());
  }
}
