package ch.unige.aou.model.xml.deposit.v1.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v1.Dataset;
import ch.unige.aou.model.xml.deposit.v1.ObjectFactory;

public class DatasetDeserializer extends AouStdDeserializer<Dataset> {

  private static final long serialVersionUID = 659865L;

  @Override
  public Dataset deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    Dataset dataset = new Dataset();

    ObjectFactory factory = new ObjectFactory();

    boolean hasValue = false;

    JsonNode urlNode = jsonNode.get("url");
    if (this.nodeHasTextValue(urlNode)) {
      dataset.getUrlOrDoi().add(factory.createDatasetUrl(urlNode.textValue()));
      hasValue = true;
    }

    JsonNode doiNode = jsonNode.get("doi");
    if (this.nodeHasTextValue(doiNode)) {
      dataset.getUrlOrDoi().add(factory.createDatasetDoi(doiNode.textValue()));
      hasValue = true;
    }

    if (hasValue) {
      return dataset;
    } else {
      return null;
    }
  }
}
