package ch.unige.aou.model.xml.deposit.v1.serializer;

import java.io.IOException;
import javax.xml.bind.JAXBElement;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.aou.model.xml.deposit.v1.Dataset;

public class DatasetSerializer extends StdSerializer<Dataset> {
  public DatasetSerializer() {
    this(null);
  }

  public DatasetSerializer(Class<Dataset> t) {
    super(t);
  }

  @Override
  public void serialize(Dataset value, JsonGenerator jgen, SerializerProvider provider) throws IOException, JsonProcessingException {
    jgen.writeStartObject();
    for (JAXBElement<String> element : value.getUrlOrDoi()) {
      jgen.writeStringField(element.getName().getLocalPart(), element.getValue());
    }
    jgen.writeEndObject();
  }
}
