package ch.unige.aou.model.xml.deposit.v1.serializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.aou.model.xml.deposit.v1.DateWithType;

public class DateWithTypeSerializer extends StdSerializer<DateWithType> {
  public DateWithTypeSerializer() {
    this(null);
  }

  public DateWithTypeSerializer(Class<DateWithType> t) {
    super(t);
  }

  @Override
  public void serialize(DateWithType value, JsonGenerator jgen, SerializerProvider provider) throws IOException, JsonProcessingException {

    jgen.writeStartObject();
    jgen.writeStringField("date", value.getContent());
    jgen.writeStringField("type", value.getType().name());
    jgen.writeEndObject();
  }
}
