package ch.unige.aou.model.xml.deposit.v2_2.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v2_2.ObjectFactory;
import ch.unige.aou.model.xml.deposit.v2_2.Publisher;

public class PublisherDeserializer extends AouStdDeserializer<Publisher> {

  private static final long serialVersionUID = 659865L;

  @Override
  public Publisher deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    Publisher publisher = new Publisher();

    ObjectFactory factory = new ObjectFactory();

    boolean hasValue = false;

    JsonNode nameNode = jsonNode.get("name");
    if (this.nodeHasTextValue(nameNode)) {
      publisher.getNameOrPlace().add(factory.createPublisherName(nameNode.textValue()));
      hasValue = true;
    }

    JsonNode placeNode = jsonNode.get("place");
    if (this.nodeHasTextValue(placeNode)) {
      publisher.getNameOrPlace().add(factory.createPublisherPlace(placeNode.textValue()));
      hasValue = true;
    }

    if (hasValue) {
      return publisher;
    } else {
      return null;
    }
  }
}
