package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.notification.NotificationType;

public class NotificationTypeSpecification extends SolidifySpecification<NotificationType> {

  private static final long serialVersionUID = -8473671588587082484L;

  public NotificationTypeSpecification(NotificationType criteria) {
    super(criteria);
  }

  @Override
  public void completePredicatesList(
          Root<NotificationType> root, CriteriaQuery<?> query, CriteriaBuilder criteriaBuilder, List<Predicate> predicatesList) {
    if (this.criteria.getEventType() != null) {
      predicatesList.add(criteriaBuilder.equal(root.get("eventType").get("resId"), this.criteria.getEventType().getResId()));
    }
  }
}
