package ch.unige.aou.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.model.publication.DocumentFile;
import ch.unige.aou.model.rest.DocumentFileStatisticsDTO;

@Repository
public interface DocumentFileRepository extends SolidifyRepository<DocumentFile> {
  @Query("SELECT new ch.unige.aou.model.rest.DocumentFileStatisticsDTO(df.status, COUNT(df.status)) "
                 + "FROM DocumentFile df "
                 + "WHERE df.publication.resId = :publicationId "
                 + "GROUP BY df.status")
  List<DocumentFileStatisticsDTO> getStatusStatistics(@Param("publicationId") String publicationId);

  @Query(value = "SELECT max(sortValue) FROM DocumentFile WHERE publication.resId = :publicationId")
  Optional<Integer> findMaxSortValueByPublication(String publicationId);
}
